//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TrayIcon.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck ͍쐬ꂽR|[lgz֐ȂƂ
// ۏ؂邽߂Ɏgp܂B
//
static inline void ValidCtrCheck(TTrayIcon *)
{
    new TTrayIcon(NULL);
}
//---------------------------------------------------------------------------
UINT TTrayIcon::IDCounter = 0;

__fastcall TTrayIcon::TTrayIcon(TComponent* Owner)
    : TComponent(Owner)
{
    UniqueID = ++IDCounter;
    FHint = "";
    FShowHint = true;
    FIcon = new TIcon;
    if (!ComponentState.Contains(csDesigning))
        FWindowHandle = AllocateHWnd(WndProc);
    else
        FIcon->Handle = LoadIcon(HInstance, "TRAY_DEFAULTICON");
    Registered = false;
}

__fastcall TTrayIcon::~TTrayIcon(void)
{
    UnregistIcon();
    if (FWindowHandle)
        DeallocateHWnd(FWindowHandle);
    delete FIcon;
}

void __fastcall TTrayIcon::RegistIcon(void)
{
    if (ComponentState.Contains(csDesigning))
        return;
    if (FIcon->Empty) {
        UnregistIcon();
        return;
    }

    IconData.cbSize = sizeof IconData;
    IconData.hWnd = FWindowHandle;
    IconData.uID = UniqueID;
    IconData.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    IconData.uCallbackMessage = WM_NOTIFYICON;
    IconData.hIcon = FIcon->Handle;
    if (FShowHint)
        lstrcpyn(IconData.szTip, FHint.c_str(), sizeof (IconData.szTip) - 1);
    else
        IconData.szTip[0] = 0;
    if (Registered)
        Shell_NotifyIcon(NIM_MODIFY, &IconData);
    else
        Shell_NotifyIcon(NIM_ADD, &IconData);
    Registered = true;
}

void __fastcall TTrayIcon::UnregistIcon(void)
{
    if (Registered)
        Shell_NotifyIcon(NIM_DELETE, &IconData);
    Registered = false;
}

void __fastcall TTrayIcon::Loaded(void)
{
    TComponent::Loaded();
    RegistIcon();
}

void __fastcall TTrayIcon::SetIcon(TIcon* Value)
{
    FIcon->Assign(Value);
    RegistIcon();
}

void __fastcall TTrayIcon::SetHint(String Value)
{
    FHint = Value;
    RegistIcon();
}

void __fastcall TTrayIcon::SetShowHint(bool Value)
{
    FShowHint = Value;
    RegistIcon();
}

void __fastcall TTrayIcon::WndProc(TMessage& Msg)
{
    POINT Pos;
    TShiftState Shift;

    if (Msg.Msg == WM_NOTIFYICON) {
        GetCursorPos(&Pos);
        if (GetKeyState(VK_SHIFT) & 0x8000)
            Shift = Shift << ssShift;
        if (GetKeyState(VK_CONTROL) & 0x8000)
            Shift = Shift << ssCtrl;
        if (GetKeyState(VK_MENU) & 0x8000)
            Shift = Shift << ssAlt;
        if (GetKeyState(VK_LBUTTON) & 0x8000)
            Shift = Shift << ssLeft;
        if (GetKeyState(VK_RBUTTON) & 0x8000)
            Shift = Shift << ssRight;
        if (GetKeyState(VK_MBUTTON) & 0x8000)
            Shift = Shift << ssMiddle;
        switch (Msg.LParam) {
        case WM_LBUTTONDOWN:
        case WM_RBUTTONDOWN:
            if (FOnMouseDown != NULL)
                FOnMouseDown(this,
                             Msg.LParam == WM_LBUTTONDOWN ? mbLeft : mbRight,
                             Shift, Pos.x, Pos.y);
            break;
        case WM_LBUTTONUP:
        case WM_RBUTTONUP:
            if (FOnMouseUp != NULL)
                FOnMouseUp(this,
                           Msg.LParam == WM_LBUTTONUP ? mbLeft : mbRight,
                           Shift, Pos.x, Pos.y);
            break;
        }
    }
    else
        Msg.Result = DefWindowProc(FWindowHandle, Msg.Msg, Msg.WParam, Msg.LParam);
}
//---------------------------------------------------------------------------
namespace Trayicon
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TTrayIcon)};
         RegisterComponents("Samples", classes, 0);
    }
}
//---------------------------------------------------------------------------
