//---------------------------------------------------------------------------
#ifndef TrayIconH
#define TrayIconH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
#include <shellapi.h>
const int WM_NOTIFYICON = WM_USER;

class PACKAGE TTrayIcon : public TComponent
{
private:
    TIcon* FIcon;
    String FHint;
    bool FShowHint;
    TMouseEvent FOnMouseDown;
    TMouseMoveEvent FOnMouseMove;
    TMouseEvent FOnMouseUp;
    HWND FWindowHandle;
    UINT UniqueID;
    static UINT IDCounter;
    NOTIFYICONDATA IconData;
    bool Registered;
    void __fastcall SetIcon(TIcon* Value);
    void __fastcall SetHint(String Hint);
    void __fastcall SetShowHint(bool Value);
    void __fastcall WndProc(TMessage& Msg);
protected:
    void __fastcall RegistIcon(void);
    void __fastcall UnregistIcon(void);
    void __fastcall Loaded(void);
public:
    __fastcall TTrayIcon(TComponent* Owner);
    __fastcall ~TTrayIcon(void);

__published:
    __property TIcon* Icon = { read=FIcon, write=SetIcon };
    __property String Hint = { read=FHint, write=SetHint };
    __property bool ShowHint = { read=FShowHint, write=SetShowHint, default=true };
    __property TMouseEvent OnMouseDown = { read=FOnMouseDown, write=FOnMouseDown };
    __property TMouseMoveEvent OnMouseMove = { read=FOnMouseMove, write=FOnMouseMove };
    __property TMouseEvent OnMouseUp = { read=FOnMouseUp, write=FOnMouseUp };
};
//---------------------------------------------------------------------------
#endif
