//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "WallPapr.h"
#pragma package(smart_init)

#pragma resource "WALLPAPR.RES"
#pragma resource "WALLSTR.RES"
//---------------------------------------------------------------------------
__fastcall TWallPaper::TWallPaper(TComponent* Owner)
    : TGraphicControl(Owner)
{
    ControlStyle = ControlStyle << csOpaque;
    Align = alClient;
    FTile = true;
    FBitmap = new Graphics::TBitmap;
}

__fastcall TWallPaper::~TWallPaper(void)
{
    delete FBitmap;
}

void __fastcall TWallPaper::SetBitmap(Graphics::TBitmap* Value)
{
    FBitmap->Assign(Value);
    Invalidate();
}

void __fastcall TWallPaper::SetTile(bool Value)
{
    if (FTile != Value) {
        FTile = Value;
        Invalidate();
    }
}

void __fastcall TWallPaper::SetType(TWallPaperType Value)
{
    if (FType != Value) {
        FType = Value;
        Graphics::TBitmap* Tmp;
        static char *ResourceNames[] = {
            "WALLPAPERANGLE", "WALLPAPERPYRAMID", "WALLPAPERCIRCLE"
        };

        try {
            if (FType != wpNone) {
                Tmp = new Graphics::TBitmap;
                Tmp->LoadFromResourceName((THandle)HInstance, ResourceNames[int(FType) - 1]);
            }
            else
                Tmp = 0;
            Bitmap = Tmp;
            if (Tmp) delete Tmp;
        }
        catch (...) {
            throw EResNotFound(LoadStr(SBmpResNotFound));
        }
    }
}

void __fastcall TWallPaper::Paint(void)
{
    if (FBitmap->Empty) {
        Canvas->Brush->Color = Color;
        Canvas->Brush->Style = bsSolid;
        Canvas->FillRect(ClientRect);
    } else if (FTile) {
        for (int i = 0; i < Width; i += FBitmap->Width)
            for (int j = 0; j < Height; j += FBitmap->Height)
                Canvas->Draw(i, j, FBitmap);
    } else {
        Canvas->Brush->Color = Color;
        Canvas->Brush->Style = bsSolid;
        Canvas->FillRect(ClientRect);
        Canvas->Draw((Width - FBitmap->Width) / 2,
                     (Height - FBitmap->Height) / 2, FBitmap);
    }
}

static void __fastcall LoadCursors(void)
{
    Screen->Cursors[crPencil] = LoadCursor(HInstance, "CURSOR_PENCIL");
    Screen->Cursors[crFeather] = LoadCursor(HInstance, "CURSOR_FEATHER");
}
#pragma startup LoadCursors
//---------------------------------------------------------------------------
namespace Wallpapr
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TWallPaper)};
         RegisterComponents("Samples", classes, 0);
    }
}
//---------------------------------------------------------------------------
