//---------------------------------------------------------------------------
#ifndef WallPaprH
#define WallPaprH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
enum TWallPaperType { wpNone, wpAngle, wpPyramid, wpCircle };

const SBmpResNotFound = 50000;

class PACKAGE TWallPaper : public TGraphicControl
{
private:
    Graphics::TBitmap* FBitmap;
    bool FTile;
    TWallPaperType FType;
    void __fastcall SetBitmap(Graphics::TBitmap* Value);
    void __fastcall SetTile(bool Value);
    void __fastcall SetType(TWallPaperType Value);
protected:
    void __fastcall Paint(void);
public:
    __fastcall TWallPaper(TComponent* Owner);
    __fastcall ~TWallPaper(void);
__published:
    __property Align = { default=alClient };
    __property Graphics::TBitmap* Bitmap = { read=FBitmap, write=SetBitmap };
    __property Color;
    __property ParentColor;
    __property bool Tile = { read=FTile, write=SetTile, default=true };
    __property TWallPaperType Type
               = { read=FType, write=SetType, default=wpNone };
};

const TCursor crPencil = -101;
const TCursor crFeather = -102;
//---------------------------------------------------------------------------
#endif
